#include "../../../logit.h"

void icmp_log(ip,icmp,data)
struct iphdr *ip;
struct icmphdr *icmp;
char *data;
{

struct in_addr addr,addr2;
char buf[BUFFSIZE];
char buffer[BUFFSIZE];

 addr.s_addr=ip->saddr;
 addr2.s_addr=ip->daddr;

 switch(icmp->type) {
   case ICMP_ECHOREPLY: 
      snprintf(buf,BUFFSIZE-1,"ICMP Echo Reply");
      break;
   case ICMP_DEST_UNREACH:
      snprintf(buf,BUFFSIZE-1,"ICMP Destination Unreachable");
      break;
   case ICMP_SOURCE_QUENCH:
      snprintf(buf,BUFFSIZE-1,"ICMP Source Quench");
      break;
   case ICMP_REDIRECT:
      snprintf(buf,BUFFSIZE-1,"ICMP Redirect");
      break;
   case ICMP_ECHO:
      snprintf(buf,BUFFSIZE-1,"ICMP Echo Request");
      break;
   case 9:
      snprintf(buf,BUFFSIZE-1,"ICMP Router Advertisement");
      break;
   case 10:
      snprintf(buf,BUFFSIZE-1,"ICMP Router Solicitation");
      break;
   case ICMP_TIME_EXCEEDED:
      snprintf(buf,BUFFSIZE-1,"ICMP Time Exceeded");
      break;
   case ICMP_PARAMETERPROB:
      snprintf(buf,BUFFSIZE-1,"ICMP Parameter Problem");
      break;
   case ICMP_TIMESTAMP:
      snprintf(buf,BUFFSIZE-1,"ICMP Timestamp Request");
      break;
   case ICMP_TIMESTAMPREPLY:
      snprintf(buf,BUFFSIZE-1,"ICMP Timestamp Reply");
      break;
   case ICMP_INFO_REQUEST:
      snprintf(buf,BUFFSIZE-1,"ICMP Information Request");
      break;
   case ICMP_INFO_REPLY:
      snprintf(buf,BUFFSIZE-1,"ICMP Information Reply");
      break;
   case ICMP_ADDRESS:
      snprintf(buf,BUFFSIZE-1,"ICMP Address Mask Request");
      break;
   case ICMP_ADDRESSREPLY:
      snprintf(buf,BUFFSIZE-1,"ICMP Address Mask Reply");
      break;
   case 37:
      snprintf(buf,BUFFSIZE-1,"ICMP Domain Name Request");
      break;
   case 38:
      snprintf(buf,BUFFSIZE-1,"ICMP Domain Name Reply");
      break;
   default:
      snprintf(buf,BUFFSIZE-1,"ICMP Unknown Type: %d",icmp->type); 
      break;
   }

   snprintf(buffer,BUFFSIZE-1,"%s from %s",buf,inet_ntoa(addr));
   snprintf(buf,BUFFSIZE-1,"%s to %s",buffer,inet_ntoa(addr2));  

   log_it(buf);         
 
}
